;Directives
#errors off
#long
#para
#trace off

;Functions
function bcd_to_bin (piByte)
{
	piByte = ((piByte and 0f0h) / 16) * 10 + (piByte and 0fh)
	return(piByte)
}


;Global variables
unsigned iSecond, iMinute, iHour
unsigned iSecondA, iMinuteA, iHourA
var32 lElapsed


if (peekb(82h) = '-' or peekb(82h) = '/') and (lcase(peekb(83h)) = 'h') then
{
	;Show copyright
	print dos cr; lf; "UPTIME R1.10             Copyright (c) 2017 by Javier Gutierrez Chamorro (Guti)"; cr; lf; "Show DOS system uptime"; cr; lf
	print dos "UPTIME [-h]"; cr; lf
        print dos "Examples:"
        print dos "	UPTIME -h"
        print dos "	Show this help screen"; cr; lf
        print dos "More information at:"; cr; lf
        print dos "	http://nikkhokkho.sourceforge.net/static.php?page=UPTIME"
        print dos "Press ENTER to continue..."
        ;key
	terminate
}

;Get RTC years if range is not valid, we assume there is not CMOS available
out 70h, 7
iSecond = in 71h
if (iSecond = 0) or (iSecond > 89h) then
{
	print dos "Error: CMOS is not available."
	terminate
}

;Get RTC seconds
out 70h, 0
iSecond = in 71h

;Get RTC minutes
out 70h, 2
iMinute = in 71h

;Get RTC hours
out 70h, 4
iHour = in 71h


;Correct to 24 hour mode if in 12 hour mode
if iHour > 81 then
{
	iHour -= 69
}

;Get alarm seconds
out 70h, 1
iSecondA = in 71h

;Get alarm minutes
out 70h, 3
iMinuteA = in 71h

;Get alarm hours
out 70h, 5
iHourA = in 71h

;If invalid alarm, then it is first execution
if (iHourA = 0) and (iMinuteA = 0) and (iSecondA = 0) or ((iHourA > 92h) and (iMinuteA > 59h) and (iSecondA > 59h)) then
{
	iHourA = iHour
	iMinuteA = iMinute
	iSecondA = iSecond

	;Set alarm seconds
	out 70h, 1
	out 71h, iSecondA
	
	;Set alarm minutes
	out 70h, 3
	out 71h, iMinuteA

	;Set alarm hours
	out 70h, 5
	out 71h, iHourA
}


iSecond = bcd_to_bin(iSecond)
iMinute = bcd_to_bin(iMinute)
iHour = bcd_to_bin(iHour)
iSecondA = bcd_to_bin(iSecondA)
iMinuteA = bcd_to_bin(iMinuteA)
iHourA = bcd_to_bin(iHourA)

;lElapsed = (bcd_to_bin(iSecond) + (bcd_to_bin(iMinute) * 60) + (bcd_to_bin(iHour) * 3600)) - (bcd_to_bin(iSecondA) + (bcd_to_bin(iMinuteA) * 60) + (bcd_to_bin(iHourA) * 3600))
;lElapsed = imul(iSecond, 1) + imul(iMinute, 60) + imul(iHour, 3600) - imul(iSecondA, 1) - imul(iMinuteA, 60) - imul(iHourA, 3600)
lElapsed = iSecond + (iMinute * 60) + (iHour * 3600) - iSecondA - (iMinuteA * 60) - (iHourA * 3600)

var32 lTemp
lTemp = lElapsed / 3600
iHourA = low lTemp

;lElapsed = lElapsed mod 3600
;mod32 is buggy in fastfunc.asm from FAST 2.92. For instance 7200 mod 3600 returns 46800 
reg bx = 3600
reg dx = high lElapsed
reg ax = low lElapsed
inline 66h, 0f7h, 0fbh	;idiv bx
push reg dx
pop iTemp16
lElapsed = iTemp16

lTemp = lElapsed / 60
iMinuteA = low lTemp

;lElapsed = lElapsed mod 60
reg bx = 60
reg dx = high lElapsed
reg ax = low lElapsed
inline 66h, 0f7h, 0fbh	;idiv bx
push reg dx
pop iTemp16
lElapsed = iTemp16

lTemp = lElapsed
iSecondA = low lTemp

if iHourA > 0 then
{
	print dos iHourA; " hour, ";
}
if (iHourA > 0) or (iMinuteA > 0) then
{
	print dos iMinuteA; " minute, ";
}
print dos iSecondA; " second, "; "1 users, load average: 0.00, 0.00, 0.00"

